//
//  YHAdopterTravelCardTableViewCell.swift
//  galaxy
//
//  Created by EDY on 2024/8/20.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHAdopterTravelCardTableViewCell: UITableViewCell {
    typealias InformationBlock = (_ type: YHCardType, _ image: UIImage, _ isleft: Bool) -> ()
    var informationBlock: InformationBlock?
    var frontLabel: UILabel!
    var backSurfaceLabel: UILabel!
    var frontImageButton: YHCardButton!
    var backSurfaceImageButton: YHCardButton!
    var frontDeleteButton: UIButton!
    var backSurfaceDeleteButton: UIButton!
    var activityIndicator: UIActivityIndicatorView!
    var viewModel: YHMainApplicantInformationViewModel! {
        didSet {
            if viewModel.mainModel.certificates.cn_identity_card.img_front.count != 0 {
                self.viewModel.getPublicImageUrl(viewModel.mainModel.certificates.cn_identity_card.img_front) {[weak self] success, error in
                    guard let self = self else { return }
                    guard let url = success else { return }
                    self.frontImageButton.kf.setBackgroundImage(with: URL(string: url), for: .normal, completionHandler:  { _ in
                        self.frontDeleteButton.isHidden = false
                    })
                    self.frontImageButton.setContent("", "")
                }
            }
            if viewModel.mainModel.certificates.cn_identity_card.img_back.count != 0 {
                self.viewModel.getPublicImageUrl(viewModel.mainModel.certificates.cn_identity_card.img_back) {[weak self] success, error in
                    guard let self = self else { return }
                    guard let url = success else { return }
                    self.backSurfaceImageButton.kf.setBackgroundImage(with: URL(string: url), for: .normal, completionHandler:  { _ in
                        self.backSurfaceDeleteButton.isHidden = false
                    })
                    self.backSurfaceImageButton.setContent("", "")
                }
            }
        }
    }

    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }

    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        selectionStyle = .none
        setupUI()
    }
    
    func setupUI() {
        contentView.backgroundColor = .clear
        backgroundColor = .clear
        
        let lineView = {
            let view = UIView()
            view.backgroundColor = UIColor.separatorColor
            return view
        }()
        contentView.addSubview(lineView)
        lineView.snp.makeConstraints { make in
            make.left.equalTo(18)
            make.top.equalTo(16)
            make.height.equalTo(1)
            make.right.equalTo(-18)
        }
        
        frontLabel = {
            let label = UILabel()
            label.font = UIFont.PFSC_R(ofSize: 12)
            label.textColor = UIColor.subTextColor
            label.text = "证件页1"
            label.textAlignment = .center
            return label
        }()
        contentView.addSubview(frontLabel)
        frontLabel.snp.makeConstraints { make in
            make.left.equalTo(18)
            make.right.equalTo(self.snp.centerX)
            make.top.equalTo(28)
            make.height.equalTo(20)
        }
        
        backSurfaceLabel = {
            let label = UILabel()
            label.font = UIFont.PFSC_R(ofSize: 12)
            label.textColor = UIColor.subTextColor
            label.textAlignment = .center
            label.text = "证件页2"
            return label
        }()
        contentView.addSubview(backSurfaceLabel)
        backSurfaceLabel.snp.makeConstraints { make in
            make.right.equalTo(-18)
            make.left.equalTo(self.snp.centerX)
            make.top.equalTo(28)
            make.height.equalTo(20)
        }
        
        frontImageButton = {
            let button = YHCardButton()
            button.setContent("card_upload", "点击上传")
            button.setBackgroundImage(UIImage(named: "service_cn_card_front"), for: .normal)
            button.addTarget(self, action: #selector(frontImageClick), for: .touchUpInside)
            button.layer.cornerRadius = 4
            button.clipsToBounds = true
            return button
        }()
        contentView.addSubview(frontImageButton)
        frontImageButton.snp.makeConstraints { make in
            make.left.equalTo(20)
            make.top.equalTo(60)
            make.height.equalTo(99)
            make.width.equalTo(160)
        }
        
        frontDeleteButton = {
            let button = UIButton(type: .custom)
            button.setBackgroundImage(UIImage(named: "service_card_delete"), for: .normal)
            button.addTarget(self, action: #selector(frontDeleteClick), for: .touchUpInside)
            button.isHidden = true
            return button
        }()
        contentView.addSubview(frontDeleteButton)
        frontDeleteButton.snp.makeConstraints { make in
            make.centerX.equalTo(frontImageButton.snp.right)
            make.centerY.equalTo(frontImageButton.snp.top)
            make.height.equalTo(21)
            make.width.equalTo(21)
        }
        
        backSurfaceImageButton = {
            let button = YHCardButton()
            button.setContent("card_upload", "点击上传")
            button.setBackgroundImage(UIImage(named: "service_cn_card_back"), for: .normal)
            button.addTarget(self, action: #selector(backSurfaceImageClick), for: .touchUpInside)
            button.layer.cornerRadius = 4
            button.clipsToBounds = true
            return button
        }()
        contentView.addSubview(backSurfaceImageButton)
        backSurfaceImageButton.snp.makeConstraints { make in
            make.right.equalTo(-20)
            make.top.equalTo(60)
            make.height.equalTo(99)
            make.width.equalTo(160)
        }

        backSurfaceDeleteButton = {
            let button = UIButton(type: .custom)
            button.setBackgroundImage(UIImage(named: "service_card_delete"), for: .normal)
            button.addTarget(self, action: #selector(backSurfaceDeleteClick), for: .touchUpInside)
            button.isHidden = true
            return button
        }()
        contentView.addSubview(backSurfaceDeleteButton)
        backSurfaceDeleteButton.snp.makeConstraints { make in
            make.centerX.equalTo(backSurfaceImageButton.snp.right)
            make.centerY.equalTo(backSurfaceImageButton.snp.top)
            make.height.equalTo(21)
            make.width.equalTo(21)
        }
        
        activityIndicator = {
            let view = UIActivityIndicatorView()
            view.style = .medium
            return view
        }()
        contentView.addSubview(activityIndicator)
        activityIndicator.snp.makeConstraints { make in
            make.center.equalTo(backSurfaceImageButton.snp.center)
            make.height.equalTo(25)
            make.width.equalTo(25)
        }
        
    }
    
    @objc func frontImageClick() {
//        if viewModel.mainModel.certificates.cn_identity_card.img_front.count != 0 {
//            if viewModel.mainModel.certificates.cn_identity_card.img_front.isEmpty == false {
//                let vc = YHImageViewController()
//                vc.imgString = viewModel.mainModel.certificates.cn_identity_card.img_front
//                UIViewController.current?.navigationController?.pushViewController(vc)
//            }
//            return
//        }
//        YHImagePickerView.show() {[weak self] image in
//            guard let self = self else { return }
//            self.frontImageButton.setContent("card_loading", "上传中")
//            self.frontImageButton.startRotationAnimation()
//            self.viewModel.uploadImage(image) {[weak self] success, error in
//                guard let self = self else { return }
//                self.frontImageButton.stopRotationAnimation()
//                self.frontImageButton.setContent("", "")
//                
//                guard let url = success else { return }
////                self.viewModel.updateModel(self.type, isFront: true, url: url)
//                self.frontImageButton.setBackgroundImage(image, for: .normal)
//                self.frontDeleteButton.isHidden = false
//                
//                self.viewModel.getPublicImageUrl(url) {[weak self] success, error in
//                    guard let self = self else { return }
//                    guard let url = success else { return }
//                    
//    
//                    self.viewModel.requestHkIDCardMessage(url, isBack: 0) {[weak self] success, error in
//                    }
//                }
//            }
//        }
    }
    
    @objc func backSurfaceImageClick() {
//        if viewModel.mainModel.certificates.hk_macao_pass.img_back.count != 0 {
//            if viewModel.mainModel.certificates.hk_macao_pass.img_back.isEmpty == false {
//                let vc = YHImageViewController()
//                vc.imgString = viewModel.mainModel.certificates.hk_macao_pass.img_back
//                UIViewController.current?.navigationController?.pushViewController(vc)
//            }
//            return
//        }
//        YHImagePickerView.show() {[weak self] image in
//            guard let self = self else { return }
//            self.backSurfaceImageButton.setContent("card_loading", "上传中")
//            self.backSurfaceImageButton.startRotationAnimation()
//            self.viewModel.uploadImage(image) {[weak self] success, error in
//                guard let self = self else { return }
//                self.backSurfaceImageButton.stopRotationAnimation()
//                self.backSurfaceImageButton.setContent("", "")
//                
//                guard let url = success else { return }
//                self.backSurfaceImageButton.setBackgroundImage(image, for: .normal)
////                self.viewModel.updateModel(self.type, isFront: false, url: url)
//                self.backSurfaceDeleteButton.isHidden = false
//                self.viewModel.getPublicImageUrl(url) {[weak self] success, error in
//                    guard let self = self else { return }
//                    guard let url = success else { return }
//                    self.viewModel.requestHkIDCardMessage(url, isBack: 1 ) {[weak self] success, error in
//                    }
//                }
//            }
//        }
    }
    
    @objc func frontDeleteClick() {
        frontDeleteButton.isHidden = true
        frontImageButton.setBackgroundImage(UIImage(named: "service_hk_card_front"), for: .normal)
        frontImageButton.setContent("card_upload", "点击上传")
    }
    
    @objc func backSurfaceDeleteClick() {
        backSurfaceDeleteButton.isHidden = true
        backSurfaceImageButton.setBackgroundImage(UIImage(named: "service_hk_card_back"), for: .normal)
        backSurfaceImageButton.setContent("card_upload", "点击上传")
    }
}
